HDU ACM 1025 Constructing Roads In JGShining's Kingdom->二分求解LIS+O(NlogN)

#include<iostream>
using namespace std;    //BFS+优先队列(打印路径)

#define N 500005
int c[N];
int dp[N];  //dp[i]保存的是长度为i的最长不降子序列的最小尾元素

int BS(int n,int x) //二分查找下标,当x比全部元素小时下标为1,比全部元素大时下标为n+1.
{
	int low,high,mid;

	low=1,high=n;
	while(low<=high)
	{
		mid=(low+high)>>1;
		if(dp[mid]==x) return mid;
		else if(dp[mid]>x) high=mid-1;
		else if(dp[mid]<x) low=mid+1;
	}
	return low;
}

int main()
{
	int t,n,a,b,i,len,pos;

	t=0;
	while(scanf("%d",&n)==1)
	{
		for(i=1;i<=n;i++)
			c[scanf("%d%d",&a,&b),a]=b;  //括号先算
		dp[0]=-1;
		dp[1]=c[1];
		len=1;
		for(i=1;i<=n;i++)
		{
			pos=BS(len,c[i]);
			dp[pos]=c[i];
			if(pos>len) len++;
		}
		printf("Case %d:\n",++t);
		if(len==1)
			printf("My king, at most %d road can be built.\n\n",len);
		else
			printf("My king, at most %d roads can be built.\n\n",len);
	}
    return 0;
}

參考自:http://blog.csdn.net/ice_crazy/article/details/7536332

如果存在一个序列d[1..9] = 2 1 5 3 6 4 8 9 7。能够看出来它的LIS长度为5。

以下一步一步试着找出它。

我们定义一个序列B,然后令 i = 1 to 9 逐个考察这个序列。

此外,我们用一个变量Len来记录如今最长算到多少了

首先,把d[1]有序地放到B里。令B[1] = 2,就是说当仅仅有1一个数字2的时候,长度为1的LIS的最小末尾是2。

这时Len=1

然后,把d[2]有序地放到B里。令B[1] = 1,就是说长度为1的LIS的最小末尾是1。d[1]=2已经没用了。非常easy理解吧。这时Len=1

接着,d[3] = 5,d[3]>B[1],所以令B[1+1]=B[2]=d[3]=5,就是说长度为2的LIS的最小末尾是5,非常easy理解吧。

这时候B[1..2]
= 1, 5,Len=2

再来。d[4] = 3,它正好加在1,5之间,放在1的位置显然不合适,由于1小于3。长度为1的LIS最小末尾应该是1。这样非常easy推知。长度为2的LIS最小末尾是3。于是能够把5淘汰掉,这时候B[1..2]
= 1, 3,Len = 2

继续,d[5] = 6。它在3后面,由于B[2] = 3, 而6在3后面。于是非常easy能够推知B[3] = 6, 这时B[1..3]
= 1, 3, 6,还是非常easy理解吧? Len = 3 了噢。

第6个, d[6] = 4,你看它在3和6之间,于是我们就能够把6替换掉。得到B[3] = 4。B[1..3] = 1,
3, 4。 Len继续等于3

第7个, d[7] = 8,它非常大,比4大,嗯。

于是B[4] = 8。Len变成4了

第8个, d[8] = 9。得到B[5] = 9。嗯。Len继续增大。到5了。

最后一个, d[9] = 7,它在B[3] = 4和B[4] = 8之间,所以我们知道,最新的B[4] =7,B[1..5]
= 1, 3, 4, 7, 9,Len = 5。

于是我们知道了LIS的长度为5。

!!!!! 注意。这个1,3,4,7,9不是LIS,它仅仅是存储的相应长度LIS的最小末尾。有了这个末尾。我们就能够一个一个地插入数据。尽管最后一个d[9]
= 7更新进去对于这组数据没有什么意义,可是假设后面再出现两个数字 8 和 9,那么就能够把8更新到d[5], 9更新到d[6]。得出LIS的长度为6。

然后应该发现一件事情了:在B中插入数据是有序的。并且是进行替换而不须要挪动——也就是说,我们能够使用二分查找,将每个数字的插入时间优化到O(logN)~~~~~于是算法的时间复杂度就减少到了O(NlogN)~

HDU ACM 1025 Constructing Roads In JGShining's Kingdom-&gt;二分求解LIS+O(NlogN)

时间: 2024-10-21 07:14:25

HDU ACM 1025 Constructing Roads In JGShining&#39;s Kingdom-&gt;二分求解LIS+O(NlogN)的相关文章

杭电 HDU ACM 1025 Constructing Roads In JGShining&#39;s Kingdom

Constructing Roads In JGShining's Kingdom Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 17732    Accepted Submission(s): 5023 Problem Description JGShining's kingdom consists of 2n(n is no mo

HDU ACM 1025 Constructing Roads In JGShining&#39;s Kingdom-&gt;二分求解LIS+O(NlogN)

#include<iostream> using namespace std; //BFS+优先队列(打印路径) #define N 500005 int c[N]; int dp[N]; //dp[i]保存的是长度为i的最长不降子序列的最小尾元素 int BS(int n,int x) //二分查找下标,当x比所有元素小时下标为1,比所有元素大时下标为n+1. { int low,high,mid; low=1,high=n; while(low<=high) { mid=(low+h

HDU 1025 Constructing Roads In JGShining&amp;#39;s Kingdom (DP)

Problem Description JGShining's kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines. Half of these cities are rich in resource (we call them rich cities) while the others are short of resource (we ca

hdoj 1025 Constructing Roads In JGShining&amp;#39;s Kingdom 【最长递增子序列】

Constructing Roads In JGShining's Kingdom Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 16262    Accepted Submission(s): 4633 Problem Description JGShining's kingdom consists of 2n(n is no mo

hdu1025 Constructing Roads In JGShining&amp;#39;s Kingdom(二分+dp)

转载请注明出处:http://blog.csdn.net/u012860063 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1025 Problem Description JGShining's kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines. Half of these cities a

hdu1025 Constructing Roads In JGShining&amp;#39;s Kingdom (nlogn的LIS)

pid=1025">题目链接 第一次写nlogn复杂度的LIS,纪念一下. 题目意思是说.有两条平行线,两条平行线都有n个城市,都是从左到右标记为1--n,一条线上是富有城市,一个是贫穷城市.输入n,接下来有n行,p,r表示穷城市p和富有城市r 之间能够建一条路(p的顺序是1--n,一个贫穷城市仅仅相应一个富有城市(弱爆的语文描写叙述能力T_T)).公路不能交叉. 问最多能够建多少条公路. 在别处看到的对nlogn解法的解释吧算是: 时间复杂度:(NlogN): 除了算法一的定义之外.添加

HDU 1025 Constructing Roads In JGShining&#39;s Kingdom   LIS 简单题 好题 超级坑

Constructing Roads In JGShining's Kingdom Problem Description JGShining's kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines. Half of these cities are rich in resource (we call them rich cities) whi

HDU 1025 Constructing Roads In JGShining&#39;s Kingdom

这是最大上升子序列的变形,可并没有LIS那么简单. 需要用到二分查找来优化. 看了别人的代码,给人一种虽不明但觉厉的赶脚 直接复制粘贴了,嘿嘿 原文链接: http://blog.csdn.net/ice_crazy/article/details/7536332 假设存在一个序列d[1..9] = 2 1 5 3 6 4 8 9 7,可以看出来它的LIS长度为5.下面一步一步试着找出它.我们定义一个序列B,然后令 i = 1 to 9 逐个考察这个序列.此外,我们用一个变量Len来记录现在最长

HDU 1025 Constructing Roads In JGShining&#39;s Kingdom(构建道路:LIS问题)

HDU 1025 Constructing Roads In JGShining's Kingdom(构建道路:LIS问题) http://acm.hdu.edu.cn/showproblem.php?pid=1025 题意: 有2n个点分布在平行的两条直线上, 上面那条是富有城市的1到n个点(从左到右分布), 下面那条是贫穷城市1到n个点(从左到右分布). 现在给出每个贫穷城市需要连接的富有城市的编号, 即(i,j)表示i贫穷城市只能连接j号富有城市 , 问你最多能构建几条贫穷城市到富有城市间